package jsim;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.border.*;

/**
The scrollable panel which contains a table. 
***/
class  DbsTable extends Box {
private String[] s;
private int npars, nsorts;
private String[] sortname, parname;
private JTree tree, atree, ttree;
private DefaultMutableTreeNode a[];
private DefaultMutableTreeNode top = new DefaultMutableTreeNode();
private TreePath vdb = new TreePath(top);
private TreePath adb = new TreePath(new DefaultMutableTreeNode());
private TreePath tdb = new TreePath(new DefaultMutableTreeNode());

private DbsTree dbsTree;
private ActionTree actionTree;
private TermTree termTree;
public WeightTree weightTree;

private Hashtable actionNodes = new Hashtable();

public boolean isAdbExpanded() {return atree!=null && adb!=null &&
              atree.isExpanded(adb);}

public boolean isTdbExpanded() {return ttree!=null && tdb!=null &&
                ttree.isExpanded(tdb);} 
                             
class ActionNode extends DefaultMutableTreeNode {
     private Hashtable argNodes = new Hashtable();
     
     public void update(Object t) {
         if (argNodes.get(t)==null) {
	     DefaultMutableTreeNode n = new DefaultMutableTreeNode(t);
             int cnt= this.getChildCount();
	     this.add(n);
	     argNodes.put(t, n);
	     DefaultTreeModel m = (DefaultTreeModel) (atree.getModel());
	     int g[]=new int[1];
	     g[0] = cnt;
	     m.nodesWereInserted(this, g);
             }
         }
	 
     ActionNode(Object s) {
        super(s);
        }
     }

class TermNode extends DefaultMutableTreeNode {
     
     public void update(Object d) {
         DefaultMutableTreeNode child = (DefaultMutableTreeNode) 
	         (this.getChildAt(0));
         if (!d.equals(child.getUserObject())) {
               child.setUserObject(d);
	       ((DefaultTreeModel) (ttree.getModel())).nodeChanged(child);
         }
       }
	 
     TermNode(Object s) {
        super(s);
        }
     }

private TermNode termNode[];  
private int sort[];
   
class FirstUpdate implements TreeWillExpandListener {
     public void treeWillExpand(TreeExpansionEvent e) throws 
        ExpandVetoException {System.err.println("Expand");};
     public void treeWillCollapse(TreeExpansionEvent e) throws 
        ExpandVetoException {System.err.println("Collapse");};   
     }
     
public void update(Vector v) { 
        // int n = s.length/3;
        DefaultTreeModel m[] = new DefaultTreeModel[] {
              ((DefaultTreeModel) (ttree.getModel())),
              ((DefaultTreeModel) (atree.getModel())),
              ((DefaultTreeModel) (tree.getModel()))
              };
        for (int i=0;i<v.size();i++) {
           // System.err.println("Help:"+(String) v.get(i)+" "+i);
           Object d = v.get(i);
           if (!d.equals(a[i].getUserObject())) {
               a[i].setUserObject(d);
               if (i<2) m[i].nodeChanged(a[i]);
               else m[2].nodeChanged(a[i]);
               }
           }
        /*
        ((AbstractTableModel) 
        table.getModel()).fireTableRowsUpdated(0, 1);
        */
        } 
	
public void actionUpdate(Vector v) {
        int n = 0, cnt= a[1].getChildCount();
        for (int i=0;i<v.size();i++) {
	   Object d = v.get(i);
	   StringTokenizer st = new StringTokenizer((String) d,"(");
	   Object s = st.nextElement();
	   ActionNode actionNode;
	   if ((actionNode=(ActionNode) (actionNodes.get(s)))==null) {
	      actionNode = new ActionNode(s);
	      a[1].add(actionNode);
	      actionNodes.put(s, (Object) actionNode);
	      n++;
	      }
	   actionNode.update(d);
           }
	 if (n>0) {
	     DefaultTreeModel m = (DefaultTreeModel) (atree.getModel());
	     int g[]=new int[n];
	     for (int i=cnt;i<a[1].getChildCount();i++) g[i-cnt] = i;
	     m.nodesWereInserted(a[1], g);
	     atree.scrollRowToVisible(atree.getRowCount()-1);
	     }
         if (a[1].getChildCount()>2 && a[1].getChildAt(0).isLeaf()) {
	     DefaultTreeModel m = (DefaultTreeModel) (atree.getModel());
             m.removeNodeFromParent((DefaultMutableTreeNode)
                  (a[1].getChildAt(0)));
             }
	 }

public void termUpdate(Vector v) {
         for (int i=0;i<nsorts;i++) {
             try {
	       Object d = v.get(npars+i);
	       termNode[i].update(new Integer((String) d));
               }
             catch (NumberFormatException e) {
                  System.err.println(e);
                  System.exit(1);
                  }
           }
         }
       	
class  ActionTree extends JScrollPane {
   
   public ActionTree() {
        a[1] = (DefaultMutableTreeNode) (adb.getLastPathComponent());
        atree = new JTree(a[1]);
        // atree.addTreeWillExpandListener(new FirstUpdate());
	atree.setShowsRootHandles(true);
        // tree.setRootVisible(false);
        atree.setVisibleRowCount(10);
        JViewport vp = new JViewport(); vp.setView(atree);
        setViewport(vp);
        setPreferredSize(new Dimension(150,150));
        setBorder(BorderFactory.createTitledBorder(
           BorderFactory.createEtchedBorder(), "action database",
               TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
        a[1].add(new DefaultMutableTreeNode("waiting"));
        }     
    }
    
class  TermTree extends JScrollPane {
   
   private String getSort(String s) {
      int pos = s.indexOf('#');
      try {
        return s.substring(pos+1);
        }
      catch (IndexOutOfBoundsException e) {
         System.err.println(e);
         System.exit(1);
         }
      return null;
      }
      
   private String getName(String s) {
      int pos = s.indexOf('#');
      try {
        return s.substring(0, pos);
        }
      catch (IndexOutOfBoundsException e) {
         System.err.println(e);
         System.exit(1);
         }
      return null;
      }
         
   public TermTree() {
        a[0] = (DefaultMutableTreeNode) (tdb.getLastPathComponent());
        ttree = new JTree(a[0]);
        // tree.setRootVisible(false);
        ttree.setVisibleRowCount(10);
	ttree.setShowsRootHandles(true);
        JViewport vp = new JViewport(); vp.setView(ttree);
        setViewport(vp);
        setPreferredSize(new Dimension(150,150));
        setBorder(BorderFactory.createTitledBorder(
           BorderFactory.createEtchedBorder(), "term database",
               TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
        parname = new String[npars];
	for (int i=0;i<npars;i++)  {
            // System.err.println(s[i]+":"+getSort(s[i]));
             parname[i] = s[i+2];
             }
        sortname = new String[nsorts];
	for (int i=0;i<nsorts;i++)  {
            // System.err.println(s[i]+":"+getSort(s[i]));
             sortname[i] = s[npars+i+2];
            }
        termNode = new TermNode[nsorts];
          for (int i=0;i<nsorts;i++) {
	    TermNode b = new TermNode(sortname[i]);
	    b.add(new DefaultMutableTreeNode("0"));
	    a[0].add(b);
	    termNode[i] = b;
	    }
    }           
}
                
class  DbsTree extends JScrollPane {
     
    
     private String[] t;
     
   
      private void createNode(DefaultMutableTreeNode node, int k) {
        try {
           int left = new Integer(t[k+1]).intValue(),
               right = new Integer(t[k+2]).intValue();
               try {
                  int idx = new Integer(t[k]).intValue();
                  a[idx] = node;
                  }
               catch (NumberFormatException e) {
                  }
           if (left>0) {
               DefaultMutableTreeNode 
               nleft = new DefaultMutableTreeNode(t[left]);
               node.add(nleft);
               createNode(nleft, left);
               }
           if (right>0) {
               DefaultMutableTreeNode 
               nright = new DefaultMutableTreeNode(t[right]);
               node.add(nright);
               createNode(nright, right);
               }
           }
       catch (NumberFormatException e) {
           System.err.println(e);
           System.exit(1);
           }
        }
        
      private void createNodes() { 
        createNode(top, 0);
        }
            
      public DbsTree() {
        int n = s.length - nsorts- npars-2;
        this.t = new String[n+3];
        a = new DefaultMutableTreeNode[n/3];
        t[0]="top";t[1]="3";t[2]="6";
        for (int i=0;i<n;i++) t[i+3]=s[npars+nsorts+i+2];
        // for (int i=0;i<t.length;i++) System.err.println(t[i]);
        tree = new JTree(top); 
	tree.setShowsRootHandles(true);
        // tree.setRootVisible(false);
        tree.setVisibleRowCount(10);
        JViewport vp = new JViewport(); vp.setView(tree);
        setViewport(vp);
        setPreferredSize(new Dimension(150,150));
        setBorder(BorderFactory.createTitledBorder(
           BorderFactory.createEtchedBorder(), "intermediate database nodes",
               TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
	createNodes();
        } 
      } // DbsTree
        public DbsTable(final String[] s) {
           super(BoxLayout.X_AXIS);
        try {
           npars = new Integer(s[0]).intValue();
           nsorts = new Integer(s[1]).intValue();
           }
           catch (NumberFormatException e) {
	   System.err.println(e);
           System.exit(1);
           }
           this.s = s;
           dbsTree = new DbsTree();
           this.add(this.dbsTree);
           this.add(Box.createHorizontalGlue());
           termTree = new TermTree();
           this.add(this.termTree);
           this.add(Box.createHorizontalGlue());
           actionTree = new ActionTree();
           this.add(this.actionTree);
           this.add(Box.createHorizontalGlue());
           weightTree = new WeightTree(Mgr.nsegments);
           this.add(this.weightTree);
           }
      }
