/*$Id: HelloMsg.java,v 1.9 2006/06/23 15:03:16 bertl Exp $*/
package jsim;

import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;

class HelloMsg extends Msg {
  final Nsim frame;
  public HelloMsg(Nsim frame) {
     setId("hello");
     this.frame = frame;
     }
     
  public HelloMsg() {
     setId("hello");
     this.frame = null;
     } 
          
  public boolean Do() {
     // Main.request.sendMsg(new StepstateMsg("0"));
      Runnable update = new Runnable() {
      public void run() {
      if (argList.size()!=6) return;
      Mgr.jid = (String) (argList.remove(0));
      Mgr.filename = (String) (argList.remove(0));
      Mgr.nsegments = 
           new Integer((String)(argList.remove(0))).intValue();
      Mgr.npars = 
           new Integer((String)(argList.remove(0))).intValue(); 
      Mgr.starttime = 
           new Date(new Integer((String)(argList.remove(0))).longValue()*1000);
      Mgr.currenttime = new Date( 
           new Integer((String)(argList.remove(0))).longValue()*1000);
      Mgr.passedtime = Mgr.currenttime.getTime()-Mgr.starttime.getTime();
      String name = new File(Mgr.filename).getName();
      Mgr.info = new Info(1, new String[]
        {"input file", "process parameters", "segments",
         "start time","current time", "passed time", "output size"});
      // System.err.println("Received:"+Mgr.starttime);
      Mgr.info.setValue(0, name);
      Mgr.info.setValue(1, new Integer(Mgr.npars).toString());
      Mgr.info.setValue(2, new Integer(Mgr.nsegments).toString());
      Mgr.info.setValue(3, DateFormat.getInstance().format(Mgr.starttime));
      Mgr.info.setValue(4, DateFormat.getInstance().format(Mgr.currenttime));
      Mgr.info.setValue(5, new Elapsed(Mgr.passedtime).toString());
      Mgr.info.setValue(6, "??");
      Mgr.table = new ProgressTable(Mgr.nsegments);
      Mgr.clientTable = new ClientTable(Mgr.nsegments);
      if (Mgr.dbsTable != null) {
         Mgr.screen = new Screen();
         Mgr.screen.setVisible(true);
         new Accept().start(); 
         }
      // System.err.println("Ended:"+Mgr.starttime); 
     }};
     try {
       SwingUtilities.invokeAndWait(update);
       }
       catch (InterruptedException e) {
        // System.err.println("Interrupted");
        }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
   }

class StartMsg extends Msg {
  final Nsim frame;
  
  public StartMsg(Nsim frame) {
     setId("start");
     this.frame = frame;
     }
     
  public StartMsg() {
     setId("start");
     this.frame = null;
     } 
       
  public boolean Do() {
     // Main.request.sendMsg(new StepstateMsg("0"));
     Runnable update = new Runnable() {
     public void run() {
        Mgr.dbsTable = new DbsTable(
           (String[]) argList.toArray(new String[0]));
     if (Mgr.clientTable!=null) {
         Mgr.screen = new Screen();
         Mgr.screen.setVisible(true);  
         new Accept().start();
         } 
     }};
     try {
       SwingUtilities.invokeAndWait(update);
       }
       catch (InterruptedException e) {
        // System.err.println("Interrupted");
        }
      catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  } 
  
class InformMsg extends Msg { 
    
  public InformMsg() {
     setId("inform");
     }
        
  public boolean Do() {
     Runnable updateTable = new Runnable() {
          public void run() {
              if (Mgr.dbsTable!=null) Mgr.dbsTable.update(argList);
          }};
     try {
       SwingUtilities.invokeAndWait(updateTable);
       }
       catch (InterruptedException e) {
        // System.err.println("Interrupted");
        }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }

class ActionMsg extends Msg {
  final Nsim frame;
  
  public ActionMsg(Nsim frame) {
     setId("action");
     this.frame = frame;
     }
     
  public ActionMsg() {
     setId("action");
     this.frame = null;
     } 
       
  public boolean Do() {
     // Main.request.sendMsg(new StepstateMsg("0"));
     Runnable update = new Runnable() {
     public void run() {
           Mgr.dbsTable.actionUpdate(argList);
     }};
     try {
       SwingUtilities.invokeAndWait(update);
       }
       catch (InterruptedException e) {
        // System.err.println("Interrupted");
        }
      catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  } 
  
class TermMsg extends Msg {
  final Nsim frame;
  
  public TermMsg(Nsim frame) {
     setId("term");
     this.frame = frame;
     }
     
  public TermMsg() {
     setId("term");
     this.frame = null;
     } 
       
  public boolean Do() {
     // Main.request.sendMsg(new StepstateMsg("0"));
     Runnable update = new Runnable() {
     public void run() {
           Mgr.dbsTable.termUpdate(argList);
     }};
     try {
       SwingUtilities.invokeAndWait(update);
       }
       catch (InterruptedException e) {
        // System.err.println("Interrupted");
        }
      catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
                      
class GoodbyeMsg extends Msg {
  final Nsim frame;
  
  public GoodbyeMsg(Nsim frame) {
     setId("goodbye");
     this.frame = frame;
     }
     
  public GoodbyeMsg(String quit) {
     setId("goodbye");
     if (Main.stateTable!=null) {
          ((Window) (Main.stateTable.getTopLevelAncestor())).dispose();
          Main.stateTable=null;
          }
     this.frame = null;
     this.addArg(quit);
     } 
       
  public boolean Do() {
     // Main.outThread.stop();
     // Main.errThread.stop();
     Runnable goodbye = new Runnable() {
            public void run() {
              
              boolean b = Boolean.valueOf
                    ((String)(argList.remove(0))).booleanValue();
              // System.out.println("Goodby1: "+b);
              if (b) {
                  b = Boolean.valueOf
                    ((String)(argList.remove(0))).booleanValue();
                 if (!b)  Main.filename=null;
                 // System.out.println("Goodby2: "+b);
                 Main.StartServer();
                 }
              else System.exit(0);
            }};
     try {
         SwingUtilities.invokeAndWait(goodbye);
         }
     catch (Exception e) {
         e.printStackTrace();
         }
     return true;
     }
  }
  
class ClearMsg extends Msg {
  final Nsim frame;
  
  public ClearMsg(Nsim frame) {
     setId("clear");
     this.frame = frame;
     }
     
  public ClearMsg() {
     setId("clear");
     this.frame = null;
     } 
       
  public boolean Do() {
     return true;
     }
  }
  
class SavetracesMsg extends Msg {
  final Nsim frame;
  
  public SavetracesMsg(Nsim frame) {
     setId("save");
     this.frame = frame;
     }
     
  public SavetracesMsg() {
     setId("save");
     this.frame = null;
     } 
       
  public boolean Do() {
     return true;
     }
  }
  
class SaveautMsg extends Msg {
  final Nsim frame;
  
  public SaveautMsg(Nsim frame) {
     setId("saveaut");
     this.frame = frame;
     }
     
  public SaveautMsg() {
     setId("saveaut");
     this.frame = null;
     } 
       
  public boolean Do() {
     return true;
     }
  }
          
class HomeMsg extends Msg {
  final Nsim frame;
  
  public HomeMsg(Nsim frame) {
     setId("home");
     this.frame = frame;
     }
     
  public HomeMsg() {
     setId("home"); // Remark: Home = redo(0)
     // this.addArg("0");
     this.frame = null;
     }
          
  public boolean Do() {
         Runnable enableHome = new Runnable() {
            public void run() {
             // System.err.println("QQ:"+"redo");
             boolean b = Boolean.valueOf
                    ((String)(argList.remove(0))).booleanValue();
             frame.homeAction.setEnabled(b); // Redo     
             }
           };
         try {
           SwingUtilities.invokeAndWait(enableHome);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
  }
  
 class ExploreMsg extends Msg {
  final Nsim frame;
  
  public ExploreMsg(Nsim frame) {
     setId("explore");
     this.frame = frame;
     }
      
 public ExploreMsg() {
     setId("explore"); 
     Main.interrupted = false;
     this.frame = null;
     }
          
  public boolean Do() {
         Runnable enableExplore = new Runnable() {
            public void run() {
             synchronized(argList) {
             boolean b = Boolean.valueOf
                    ((String)(argList.remove(0))).booleanValue();
             if (!frame.timer.isRunning()) {
                 frame.interruptAction.setEnabled(!b); 
                 frame.enableMenu(b);
                 }
             }
           }};
         try {
           SwingUtilities.invokeAndWait(enableExplore);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
         }
  
class SearchMsg extends Msg {
  final Nsim frame;
  
  public SearchMsg(Nsim frame) {
     setId("labels");
     this.frame = frame;
     }
      
 public SearchMsg() {
     setId("labels"); 
     this.frame = null;
     }
          
  public boolean Do() {
         Runnable enableSearch = new Runnable() {
            public void run() {
             synchronized(argList) {
             
             int n = argList.size()/2;
             for (int i=0;i<n;i++) {
               labels.put(argList.get(i), argList.get(n+i));
               }
             Object a[] = argList.subList(0, n).toArray();
             Arrays.sort(a);
             JList list = new JList(a);
             if (JOptionPane.showConfirmDialog(frame,  
                new JScrollPane(list), "Search", JOptionPane.OK_CANCEL_OPTION)
                ==JOptionPane.OK_OPTION) {
             Main.request.sendMsg(new SelectMsg(list.getSelectedValues()));
                };
             } 
             }
           };
         try {
           SwingUtilities.invokeAndWait(enableSearch);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
  }

class StateMsg extends Msg {
  final Nsim frame;
  
  public StateMsg(Nsim frame) {
     setId("state");
     this.frame = frame;
     }
      
 public StateMsg(boolean b) {
     setId("state"); 
     this.frame = null;
     this.addArg(b?"1":"0");
     }
          
  public boolean Do() {
         Runnable displayState = new Runnable() {
            public void run() {
             synchronized(argList) {
               if (Main.stateTable==null) {
                 Main.stateTable= new StateTable(argList);
                 final JFrame f = new JFrame("Current State");
                 f.setSize(300,600);
                 f.getContentPane().add(Main.stateTable);
                 f.addWindowListener(new WindowAdapter() {
                     public void windowClosing(WindowEvent ev) {
                     Main.stateTable = null;
                     Main.request.sendMsg(new StateMsg(false));
                     Main.frame.enableDisplayState(true);
                     f.dispose();
                     }
                  });
                 Main.frame.enableDisplayState(false);
                 f.setVisible(true);
                 }
               else 
                 Main.stateTable.update(argList, false);
             } 
             }
           };
         try {
           SwingUtilities.invokeAndWait(displayState);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
  } 
  
  class UpdateStateMsg extends Msg {
  final Nsim frame;
  
  public UpdateStateMsg(Nsim frame) {
     setId("updatestate");
     this.frame = frame;
     }
      
 public UpdateStateMsg(int v, String s) {
     setId("updatestate"); 
     this.frame = null;
     this.addArg(new Integer(v).toString());
     this.addArg(s);
     }
          
  public boolean Do() {
         Runnable displayState = new Runnable() {
            public void run() {
             synchronized(argList) {
               if (Main.stateTable==null) return;
               else Main.stateTable.update(argList, true);
             } 
             }
           };
         try {
           SwingUtilities.invokeAndWait(displayState);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
  }   
class SelectMsg extends Msg {
  final Nsim frame;
  
  public SelectMsg(Nsim frame) {
     setId("search");
     this.frame = frame;
     }
      
 public SelectMsg(Object[] sels) {
     setId("search"); 
     this.frame = null;
     this.addArg(Integer.toString(sels.length));
     for (int i=0;i<sels.length;i++) {
          this.addArg(labels.get(sels[i]).toString());
          }
     labels.clear();
     }
          
  public boolean Do() {
     return true;
     }
  } 
  
class ContinueMsg extends Msg {
  final Nsim frame;
  
  public ContinueMsg(Nsim frame) {
     setId("continue");
     this.frame = frame;
     }
      
 public ContinueMsg() {
     setId("continue"); 
     // System.err.println("Do continue");
     this.frame = null;
     this.addArg(Main.interrupted?"1":"0");
     }
          
  public boolean Do() {
     Main.request.sendMsg(new ContinueMsg());
     return true;
     }
  }
         
class LevelUpMsg extends Msg {
  final Nsim frame;
  
  public LevelUpMsg(Nsim frame) {
     setId("levelup");
     this.frame = frame;
     }
     
  public LevelUpMsg() {
     setId("levelup"); 
     this.frame = null;
     }
          
  public boolean Do() {
         Runnable enableLevelUp = new Runnable() {
            public void run() {
             // System.err.println("QQ:"+"redo");
             synchronized(argList) {
             boolean b = Boolean.valueOf
                    ((String)(argList.remove(0))).booleanValue();
             if (!frame.chooser.isAutFile()) 
                frame.levelUpAction.setEnabled(b); 
             Main.interrupted = false;     
             }
             }
           };
         try {
           SwingUtilities.invokeAndWait(enableLevelUp);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
  }
   
class LevelDownMsg extends Msg {
  final Nsim frame;
  
  public LevelDownMsg(Nsim frame) {
     setId("leveldown");
     this.frame = frame;
     }
     
  public LevelDownMsg() {
     setId("leveldown"); 
     this.frame = null;
     }
          
  public boolean Do() {
         Runnable enableLevelDown = new Runnable() {
            public void run() {
             // System.err.println("QQ:"+"redo");
             synchronized(argList) {
             boolean b = Boolean.valueOf
                    ((String)(argList.remove(0))).booleanValue();
             if (!frame.chooser.isAutFile()) 
                frame.levelDownAction.setEnabled(b);     
             }
             }
           };
         try {
           SwingUtilities.invokeAndWait(enableLevelDown);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
  }
        
class ResetMsg extends Msg {
  final Nsim frame;
  
  public ResetMsg(Nsim frame) {
     setId("reset");
     this.frame = frame;
     }
     
  public ResetMsg() {
     setId("reset");
     this.frame = null;
     } 
       
  public boolean Do() {
     Runnable enableReset = new Runnable() {
          public void run() {
              // System.err.println("QQ:"+"redo");
            if (!frame.chooser.isAutFile()) {
               boolean b = Boolean.valueOf
                      ((String)(argList.remove(0))).booleanValue();
               frame.resetAction.setEnabled(b); // Redo 
               }   
            }
          };
     try {
       SwingUtilities.invokeAndWait(enableReset);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     // Main.request.sendMsg(new StepstateMsg("0"));
     return true;
     }
  }
  
 class UndoMsg extends Msg {
  final Nsim frame; 
    
  public UndoMsg() {
     setId("undo");
     this.frame = null;
     }
     
  public UndoMsg(Nsim frame) {
     setId("undo");
     this.frame = frame;
     }
       
  public boolean Do() {
     Runnable enableUndo = new Runnable() {
          public void run() {
              // System.err.println("QQ:"+"redo");
              boolean b = Boolean.valueOf
                     ((String)(argList.remove(0))).booleanValue();
              frame.undoAction.setEnabled(b); // Redo    
              }
          };
     try {
       SwingUtilities.invokeAndWait(enableUndo);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }   
  }
  
class ParentMsg extends Msg {
  final Nsim frame;
    
  public ParentMsg() {
     setId("parent");
     this.frame = null;
     }
     
   public ParentMsg(Nsim frame) {
     setId("parent");
     this.frame = frame;
     } 
       
  public boolean Do() {
     Runnable enableParent = new Runnable() {
          public void run() {
              // System.err.println("QQ:"+"redo");
              synchronized(argList) {
              boolean b = Boolean.valueOf
                     ((String)(argList.remove(0))).booleanValue();
              frame.parentAction.setEnabled(b); // Redo     
              }
              }
          };
     try {
       SwingUtilities.invokeAndWait(enableParent);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }      
  }

class DisplayMsg extends Msg {
  final Nsim frame;
  
  public DisplayMsg(Nsim frame) {
     setId("display");
     this.frame = frame;
     }
          
  public boolean Do() {
     Runnable display = new Runnable() {
          public void run() {
              // System.err.println("QQ:"+"redo"); 
             synchronized(argList) {
                 MyModel mymodel = (MyModel) frame.choice.actions.getModel();
                 mymodel.setLocal(argList);
              }
              }
          };
     try {
       SwingUtilities.invokeAndWait(display);
       }
     catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  } 
     
class RedoMsg extends Msg {
  final Nsim frame;
  
  public RedoMsg(Nsim frame) {
     setId("redo");
     this.frame = frame;
     }
     
  public RedoMsg() {
     setId("redo");
     this.addArg(String.valueOf(-1));
     this.frame = null;
     }
      
  public RedoMsg(String pos) {
     setId("redo");
     this.frame = null;
     this.addArg(pos);
     } 
          
  public boolean Do() {
         Runnable enableRedo = new Runnable() {
            public void run() {
             // System.err.println("QQ:"+"redo");
             boolean b = Boolean.valueOf
                    ((String)(argList.remove(0))).booleanValue();
             frame.redoAction.setEnabled(b); // Redo     
             }
           };
         try {
           SwingUtilities.invokeAndWait(enableRedo);
           }
         catch (Exception e) {
            e.printStackTrace();
            }
         return true;
         }
  }
      
 class ChildMsg extends Msg {
  final Nsim frame;
  
  public ChildMsg(Nsim frame) {
     setId("child");
     this.frame = frame;
     }
     
  public ChildMsg() {
     setId("child");
     this.frame = null;
     } 
       
  public boolean Do() {
     Runnable enableChild = new Runnable() {
          public void run() {
              // System.err.println("QQ:"+"redo");
              frame.childAction.setEnabled(Boolean.valueOf
                     ((String)(argList.remove(0))).booleanValue()); // Redo     
              }
          };
     try {
       SwingUtilities.invokeAndWait(enableChild);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
  
class LeftMsg extends Msg {
  final Nsim frame;
  
  public LeftMsg(Nsim frame) {
     setId("left");
     this.frame = frame;
     }
     
  public LeftMsg() {
     setId("left");
     this.frame = null;
     }
         
  public boolean Do() {
     Runnable enableLeft = new Runnable() {
          public void run() {
              // System.err.println("QQ:"+"redo");
              frame.leftAction.setEnabled(Boolean.valueOf
                     ((String)(argList.remove(0))).booleanValue()); // Redo     
              }
          };
     try {
       SwingUtilities.invokeAndWait(enableLeft);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
  
  class RightMsg extends Msg {
  final Nsim frame;
  
  public RightMsg(Nsim frame) {
     setId("right");
     this.frame = frame;
     }
     
  public RightMsg() {
     setId("right");
     this.frame = null;
     } 
       
  public boolean Do() {
     Runnable enableRight = new Runnable() {
          public void run() {
              // System.err.println("QQ:"+"redo");
              frame.rightAction.setEnabled(Boolean.valueOf
                     ((String)(argList.remove(0))).booleanValue()); // Redo     
              }
          };
     try {
       SwingUtilities.invokeAndWait(enableRight);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
