/* $Id: Help.java,v 1.1 2004/01/09 14:59:58 bertl Exp $ */
package jsim;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.util.jar.*;
import java.util.zip.ZipEntry;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.EditorKit;
import javax.swing.text.html.*;

class Help extends JFrame {
  Help(String fileName) {
        super("Help info");
        final JEditorPane jep = new JEditorPane();
        // jep.setFont(font);
        jep.setEditable(false);
        EditorKit htmlKit = jep.getEditorKitForContentType("text/html");
        HTMLDocument doc = (HTMLDocument) htmlKit.createDefaultDocument();
        InputStream in = null;
        jep.setEditorKit(htmlKit);
        try {
            File file = new File(fileName);
            in = (InputStream) new FileInputStream(file);
            } 
        catch(FileNotFoundException fnf) {
            try {
               String classPath = System.getProperty("java.class.path",".");
               StringTokenizer st = new StringTokenizer(classPath, ":", false);
               while (st.hasMoreTokens()) {
                 String s = st.nextToken();
                 File f = new File(s);
                 // System.err.println("aap:"+f.getName());
                 if (f.isFile() && f.getName().equals("jsim.jar")) {
                 JarFile file = new JarFile(f);
                 ZipEntry zipEntry = file.getEntry("jsim/"+fileName);
                 if (zipEntry != null)
                    in = (InputStream) file.getInputStream(zipEntry);
                    break;
                 }
                }
              } 
            catch(FileNotFoundException e) {
                System.err.println(e);
                System.exit(1);
                }
            catch (IOException e) {
                System.err.println(e);
                System.exit(1);
                } 
            }
        if (in!=null) {
           try {
              jep.read(in,doc);
              jep.setCaretPosition(0);
              }
           catch (IOException e) {
              System.err.println(e);
              System.exit(1);
              }
        }   
        JScrollPane scrollPane = new JScrollPane(jep);
        // scrollPane.getViewport().updateUI();
        
        // f.setFont(font);
        setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        setContentPane(scrollPane);
        setSize(512,342);
        /*
        f.addWindowListener(new WindowAdapter() {
		    public void windowActivated(WindowEvent w) {
                    jep.scrollRectToVisible(new Rectangle(0,0));
		    }
		});
        */	
        }
        }
