/*$Id: Main.java,v 1.8 2006/11/16 14:55:04 bertl Exp $*/
package jsim;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

class Info extends JPanel {
     private JLabel[] labels;
     private String[] s;
     Info(int nrows, String[] s) {
         this.s = s;
         setLayout(new GridLayout(nrows , s.length/nrows));
         labels = new JLabel[s.length];
         for (int i=0;i<s.length;i++) {
             JLabel jlabel = new JLabel();
             jlabel.setBorder(BorderFactory.createTitledBorder(s[i]));
             labels[i] = jlabel;
             this.add(jlabel);
             }
         }
         
     public String getValue(int i) {return labels[i].getText();} 
     
     public void setValue(int i, String s) {labels[i].setText(s);} 
     
     public int getIntValue(int i) {
        String t = getValue(i);
        try {
            return new Integer(t).intValue();
            }
        catch (NumberFormatException e) {
              e.printStackTrace();
              System.exit(1); 
        }
     return 32;
     }
     
     Vector update(Vector v) {
         for (int i=0;i<labels.length;i++) {
            String val = (String) (v.remove(0));
            labels[i].setText(val);
            }
         return v;
         }
     }
     
class Nsim extends JFrame implements ActionListener { 
   boolean first = true;
   MyFileChooser chooser;
   ArrayList cmd;   
   class FileopenAction extends AbstractAction {
          private JFrame parent;
          FileopenAction(String text, JFrame parent) {
              super(text);
              this.parent = parent;
              }
          public void actionPerformed(ActionEvent e) {
                if (chooser.getSelectedFile()!=null)
                   chooser.oldFile = chooser.getSelectedFile();
                while (chooser.showOpenDialog(parent)==JFileChooser.
           APPROVE_OPTION && chooser.getSelectedFile()!=null) {
                  if (chooser.getSelectedFile().isFile()) {
                     Main.filename = chooser.getSelectedFile().getAbsolutePath();
                     Main.cmd.add(Main.filename);
                     if (!first) {
                        Main.request.sendMsg(new GoodbyeMsg("false"));
                        setAll(false);
                        }
                     return;
                     }
                  if (chooser.getSelectedFile().isDirectory()) {
                     String s = chooser.getSelectedFile().getName();
                     int n = s.lastIndexOf('.');
                     String suffix = n>=0?s.substring(n):s;
                     if (chooser.suffixToFilter.get((Object) suffix)!=null) {
                     Main.filename = chooser.getSelectedFile().getAbsolutePath();
                     Main.cmd.add(Main.filename);
                     if (!first) Main.request.sendMsg(new GoodbyeMsg("false"));
                     return;
                     } 
                     chooser = new MyFileChooser(chooser.getSelectedFile());  
                     }
                   }
                if (first) System.exit(1);
                if (chooser.oldFile != null) {
                   Main.cmd.add(chooser.oldFile.getAbsolutePath());
                   chooser.setSelectedFile(chooser.oldFile);
                   }
                else System.exit(1);
                }
        }
          
   abstract class ExtendAction extends AbstractAction {
          public ExtendAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon);
              putValue(SHORT_DESCRIPTION, desc);
              putValue(MNEMONIC_KEY, mnemonic);
          }
          }

   class UndoAction extends ExtendAction {
          public UndoAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
             setAll(false);
             Main.request.sendMsg(new UndoMsg());
             }
          }
          
   class ParentAction extends ExtendAction {
          public ParentAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
             setAll(false);
             Main.request.sendMsg(new ParentMsg());
             }
          }
          
   class ChildAction extends ExtendAction {
          public ChildAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
             setAll(false);
             Main.request.sendMsg(new ChildMsg());
             }
          }
                 
   class RedoAction extends ExtendAction {
          public RedoAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
             setAll(false);
             Main.request.sendMsg(new RedoMsg());
             }
          }
          
   class LeftAction extends ExtendAction {
          public LeftAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
                setAll(false);
                Main.request.sendMsg(new LeftMsg());
             }
          }
          
   class RightAction extends ExtendAction {
          public RightAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
               setAll(false);
               Main.request.sendMsg(new RightMsg());
             }
          }
                 
   class ResetAction extends ExtendAction {
          public ResetAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
              setAll(false);
              Main.request.sendMsg(new ResetMsg());
              choice.depthAction.setText("init");
              }
          }
          
    class HomeAction extends ExtendAction {
          public HomeAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
              setAll(false);
              Main.request.sendMsg(new HomeMsg());
              choice.depthAction.setText("init");
              }
          } 
          
    class LevelUpAction extends ExtendAction {
          public LevelUpAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
              setAll(false);
              Main.request.sendMsg(new LevelUpMsg());
              }
          }
          
    class LevelDownAction extends ExtendAction {
          public LevelDownAction(String text, ImageIcon icon,
                            String desc, Integer mnemonic) {
              super(text, icon, desc, mnemonic);
          }
          public void actionPerformed(ActionEvent e) {
              setAll(false);
              // System.err.println("actionPerformed:"+
              // SwingUtilities.isEventDispatchThread());
               Main.request.sendMsg(new LevelDownMsg());
              }
          }             
    protected static ImageIcon createNavigationIcon(String imageName) {
    String imgLocation = "toolbarButtonGraphics/navigation/"
                         + imageName
                         + ".gif";
    java.net.URL imageURL = ClassLoader.getSystemResource(imgLocation);

    if (imageURL == null) {
        System.err.println("Resource not found: "
                           + imgLocation);
        return null;
    } else {
        return new ImageIcon(imageURL);
    }
   }
   
   
   protected static ImageIcon createGeneralIcon(String imageName) {
    String imgLocation = "toolbarButtonGraphics/general/"
                         + imageName
                         + ".gif";
    java.net.URL imageURL = ClassLoader.getSystemResource(imgLocation);

    if (imageURL == null) {
        System.err.println("Resource not found: "
                           + imgLocation);
        return null;
    } else {
        return new ImageIcon(imageURL);
    }
   }
   
   void enableMenu(boolean b) {
     // interruptAction.setEnabled(b);
     // System.err.println("enableMenu:"+b);
     exploreAction.setEnabled(b);
     searchAction.setEnabled(b);
     if ((Main.stateTable!=null && !Main.stateTable.isVisible())
        && (chooser==null || !chooser.isAutFile())) 
         stateAction.setEnabled(b);
     clearAction.setEnabled(b);
     saveautAction.setEnabled(b);
     if (chooser==null || !chooser.isAutFile())
         savetracesAction.setEnabled(b);
     randomwalkAction.setEnabled(b);
     }
   
   void enableDisplayState(boolean b) {
     stateAction.setEnabled(b);
     }
      
   final protected Action 
   undoAction = new UndoAction("Undo",
                                      createGeneralIcon("Undo16"),
                                      "Undoes the last step", 
                                      new Integer(KeyEvent.VK_Z)),
   parentAction = new ParentAction("Parent",
                                      createNavigationIcon("Down16"),
                                      "Goes to the parent node", 
                                      new Integer(KeyEvent.VK_D)),
   redoAction = new RedoAction("Redo",
                                      createGeneralIcon("Redo16"),
                                      "Redoes the last step", 
                                      new Integer(KeyEvent.VK_U)),
   childAction = new ChildAction("Child",
                                      createNavigationIcon("Up16"),
                                      "Goes to the left most child", 
                                      null),
   leftAction = new LeftAction("Left",
                                      createNavigationIcon("Back16"),
                                      "Goes to the left neighbour", 
                                      new Integer(KeyEvent.VK_L)),
   rightAction = new RightAction("Right",
                                      createNavigationIcon("Forward16"),
                                      "Goes to the right neighbour", 
                                      new Integer(KeyEvent.VK_R)), 
   homeAction = new HomeAction("Home",
                                      createNavigationIcon("Home16"),
                                      "Goes to the initial state",
                                      null), 
   resetAction = new ResetAction("Reset",
                                      createGeneralIcon("Delete16"),
                                      "Reset",
                                      null),
   levelUpAction = new LevelUpAction("LevelUp",
                                      createGeneralIcon("Export16"),
                   "Explores and increases the current level",
                                      null),
   levelDownAction = new LevelDownAction("LevelDown",
                                      createGeneralIcon("Import16"),
                 "Destroys all higher levels and decreases the current level",
                                      null),
   exploreAction = new AbstractAction("Breadth first") {
                    public void actionPerformed(ActionEvent e) {
                     setAll(false);
                     interruptAction.setEnabled(true);
                     Main.request.sendMsg(new ExploreMsg());
                     }},
   interruptAction = new AbstractAction("Interrupt") {
                    public void actionPerformed(ActionEvent e) {
                     if (timer.isRunning()) {
                        timer.stop();
                        }
                     else Main.interrupted=true;
                     interruptAction.setEnabled(true);
                     enableMenu(true);
                     }},
   searchAction = new AbstractAction("Labels") {
                    public void actionPerformed(ActionEvent e) {
                     Main.request.sendMsg(new SearchMsg());
                     }},
   stateAction = new AbstractAction("States") {
                    public void actionPerformed(ActionEvent e) {
                     Main.request.sendMsg(new StateMsg(true));
                     }},
   clearAction = new AbstractAction("Clear") {
                    public void actionPerformed(ActionEvent e) {
                     Main.request.sendMsg(new ClearMsg());
                     }},
   savetracesAction = new AbstractAction("Save traces to marked transitions") {
                    public void actionPerformed(ActionEvent e) {
                     Main.request.sendMsg(new SavetracesMsg());
                     }},
   saveautAction = new AbstractAction("Save transition system") {
                    public void actionPerformed(ActionEvent e) {
                     Main.request.sendMsg(new SaveautMsg());
                     }},
   randomwalkAction = new AbstractAction("Random") {
                    public void actionPerformed(ActionEvent e) {
                     // setAll(false);
                     interruptAction.setEnabled(true);
                     if (!timer.isRunning()) timer.start(); 
                     }},
   quitAction = new AbstractAction("Exit") {
       public void actionPerformed(ActionEvent e) {
           Main.request.sendMsg(new GoodbyeMsg("true"));
           // System.exit(0);
       }},
   helpIntroAction = new AbstractAction("Intro") {
       public void actionPerformed(ActionEvent e) {
           new Help("intro.html").show();
       }},
   helpLegendAction = new AbstractAction("Legend") {
       public void actionPerformed(ActionEvent e) {
           new Help("legend.html").show();
       }
   },
   fileopenAction = new FileopenAction("Open",this);
   final JTextArea log = new JTextArea();
   final ChoiceBuild choice = new ChoiceBuild(); 
   final Mark nodes = new Mark(); 
   
   
   Random random = new Random(
       Integer.getInteger("random,",1953).intValue());
   JButton[] buttons;
   static boolean stop = false;
   static int cnt = 0;
   private boolean allEnabled() {
      boolean r = true;
      for (int i=0;i<buttons.length;i++)
      if (buttons[i].isEnabled()) r = false;
      r = (r && choice.actions.isEnabled());
      // System.out.println("r="+r);
      return r;
      }
      
   public void actionPerformed(ActionEvent ae) {
           if (!homeAction.isEnabled()) return;
           /*
           for (int i=0;i<buttons.length;i++) System.out.print(" "+
           buttons[i].isEnabled());
           System.out.println();
           */
           int k = 
           random.nextInt(buttons.length+choice.actions.getModel().getSize());
           if (k<buttons.length) 
              {
              if (buttons[k].isEnabled()) {
                   // System.err.println("Name:"+buttons[k].getIcon()); 
                   if (!stop) {
                      buttons[k].doClick();
                      // stop = true;
                      }
                   }
              }
          
           else  {
              if (choice.actions.isEnabled()) {
                 /* System.err.println("Action preformed:"+k+ " "+
                 choice.actions.getModel().getSize()); */
                 if (!stop) {
                   choice.actions.setSelectedIndex(k-buttons.length);
                   // stop = true;
                   }
                 }
                
              }
              /*
              if (!allEnabled()) 
              if (cnt==10) stop = false;
              cnt = (cnt<10?cnt+1:0);
              */
           }
           
   javax.swing.Timer timer = new javax.swing.Timer(50, this);
       
   void setAll(boolean b) {
       // synchronized(choice.actions) {
       // System.err.println("setAll:"+b);
       // choice.actions.setEnabled(b);
       homeAction.setEnabled(b);
       leftAction.setEnabled(b);
       rightAction.setEnabled(b);
       parentAction.setEnabled(b);
       childAction.setEnabled(b);
       undoAction.setEnabled(b);
       redoAction.setEnabled(b);
       choice.actions.setEnabled(b);
       choice.depthAction.setEnabled(b);
       if (chooser==null || !chooser.isAutFile()) {
          levelUpAction.setEnabled(b);
          levelDownAction.setEnabled(b);
          resetAction.setEnabled(b);
          }
       // enableMenu(b);
       // }
       }
           
   Nsim() {
     JPanel toolbars = new JPanel();
     JToolBar tb1 = new JToolBar();
     JButton b;
     ArrayList action = new ArrayList();
     setAll(false);
     setFocusable(false);
     tb1.setBorder(BorderFactory.createTitledBorder(
     BorderFactory.createEtchedBorder(), "Navigate",
     TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
     action.add((b=tb1.add(leftAction)));
     b.setFocusable(false);
     action.add((b=tb1.add(parentAction)));
     b.setFocusable(false);
     action.add((b=tb1.add(childAction)));
     b.setFocusable(false);
     action.add((b=tb1.add(rightAction)));
     b.setFocusable(false);
     tb1.add(homeAction).setFocusable(false);
     action.add((b=tb1.add(undoAction)));
     b.setFocusable(false);
     action.add((b=tb1.add(redoAction)));
     b.setFocusable(false);
     /* tb1.add(new AbstractAction("exit") {
         public void actionPerformed(ActionEvent e) {
              System.exit(0);
              };
         });
     */
     this.setSize(Main.width,650);
     getContentPane().setLayout(new BoxLayout(getContentPane(), 
              BoxLayout.Y_AXIS));
     
     toolbars.add(tb1);
     JToolBar tb2 = new JToolBar();
     tb2.setBorder(BorderFactory.createTitledBorder(
     BorderFactory.createEtchedBorder(), "Update",
     TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
     tb2.add(resetAction).setFocusable(false);
     action.add((b=tb2.add(levelUpAction)));
     b.setFocusable(false);
     action.add((b=tb2.add(levelDownAction)));
     b.setFocusable(false);
     action.add((b=choice.depthAction));
     b.setFocusable(false);
     toolbars.add(tb2);
     getContentPane().add(toolbars);
     Box panel = Box.createHorizontalBox();
     panel.add(choice);
     panel.add(nodes);
     getContentPane().add(panel);
     ((JComponent)(getContentPane().add(Main.info))).
       setMinimumSize(new Dimension(Main.width,70));
     getContentPane().add(new JScrollPane(log));
     log.setEditable(false);
     log.setRows(6);
     JMenuBar jMenuBar=new JMenuBar();
     JMenuBar jBar=new JMenuBar();
     JMenuBar jHelpMenuBar=new JMenuBar();
     jBar.setLayout(new BorderLayout());
     JMenu fileMenu = new JMenu("File");
     JMenu exploreMenu=new JMenu("Explore");
     JMenu displayMenu=new JMenu("Display");
     JMenu searchMenu=new JMenu("Search");
     JMenu markMenu=new JMenu("Markers");
     JMenu helpMenu=new JMenu("Help");
     helpMenu.add(helpIntroAction);
     helpMenu.add(helpLegendAction);
     jMenuBar.add(fileMenu);
     jMenuBar.add(exploreMenu);
     jMenuBar.add(displayMenu);
     jMenuBar.add(searchMenu);
     jMenuBar.add(markMenu);
     jHelpMenuBar.add(helpMenu);
     jBar.add("West", jMenuBar);
     JLabel lab = new JLabel("jsim v"+ System.getProperty("version","0"),
     JLabel.CENTER);
     // lab.setBorder(BorderFactory.createEtchedBorder());
     lab.setForeground(Color.gray);
     jBar.add("Center", lab);
     jBar.add("East", jHelpMenuBar);
     fileMenu.add(fileopenAction);
     fileMenu.add(savetracesAction);
     fileMenu.add(saveautAction);
     fileMenu.add(quitAction);
     exploreMenu.add(exploreAction);
     exploreMenu.add(randomwalkAction);
     exploreMenu.add(interruptAction);
     searchMenu.add(searchAction);
     displayMenu.add(stateAction);
     markMenu.add(clearAction);
     setJMenuBar(jBar);
     buttons = ((JButton[]) action.toArray(new JButton[0]));
     addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent wev) {
            Main.request.sendMsg(new GoodbyeMsg("true"));
            // System.exit(0);
        }
      });
     timer.setCoalesce(true);
     }
   }
   
public class Main  {
    static Runtime runtime = Runtime.getRuntime();;
    static Process server;
    static InputStream in;
    static OutputStream out;
    static InputStream err;
    static MsgHandler request; 
    static MsgHandler printmsg;
    static Thread outThread, errThread;
    static int width = 630;
    static final Info info = new Info(3, new String[]{"level", "explored", "visited",
       "transitions",
        "until level", "explored","visited", "transitions",
       "total levels","explored","visited", "transitions"});
    static Nsim frame = new Nsim(); 
    static ArrayList cmd;
    static boolean interrupted = false;
    static String[] args;
    static String filename = null;
    static StateTable stateTable = null;
    static File file = null;
    static Object msg[][] =  new Object[][] {
          {"hello", new HelloMsg(frame)},
          {"goodbye", new GoodbyeMsg(frame)},
          {"steprank",new SteprankMsg(frame)},
          {"reset",new ResetMsg(frame)},
          {"home",new HomeMsg(frame)},
          {"display",new DisplayMsg(frame)},
          {"parent",new ParentMsg(frame)},
          {"child",new ChildMsg(frame)},
          {"undo",new UndoMsg(frame)},
          {"redo", new RedoMsg(frame)},
          {"left", new LeftMsg(frame)},
          {"right", new RightMsg(frame)},
          {"info",new InfoMsg(info)},
          {"smd",new SmdMsg(frame)},
          {"depthcontent",new DepthcontentMsg(frame)},
          {"mark",new MarkMsg(frame)},
          {"levelup",new LevelUpMsg(frame)},
          {"leveldown",new LevelDownMsg(frame)},
          {"explore",new ExploreMsg(frame)},
          {"labels",new SearchMsg(frame)},
          {"state",new StateMsg(frame)},
	  {"updatestate",new UpdateStateMsg(frame)},
          {"continue",new ContinueMsg(frame)}
          };
          
    static private boolean Server() {
        try {
        server = runtime.exec((String[]) cmd.toArray(new String[0]));
        err = server.getErrorStream();
        in = server.getInputStream();
        out = server.getOutputStream();
        errThread = new Thread(new ErrorMsg(frame, err));
        errThread.start();
        // cmd.remove(cmd.size()-1);
        // System.err.println("Finish");
        // frame = new Nsim();
        request = new MsgHandler(in, out, frame, msg);
        outThread = new Thread(request);
        outThread.start();
        request.sendMsg(new HelloMsg());
        return false;
        }
        catch (IOException e) {
           e.printStackTrace();
        return true;
        }
        }
        
    static void StartServer() {
        // System.err.println("cmd:"+cmd);
        if (filename==null) { 
         frame.chooser.setSelectedFile(null);
         frame.fileopenAction.actionPerformed(null);
         } 
        else {
         frame.chooser.setSelectedFile(file);
         frame.setTitle(file.getAbsolutePath());
         cmd.add(filename);
         // System.out.println(cmd);
         }
        frame.show();
        boolean err = Server();
        /*
        while (err) {
            JOptionPane.showMessageDialog(frame, "File "+ 
            cmd.get(cmd.size()-1)+" does not exist");
            cmd.remove(cmd.size()-1);
            frame.fileopenAction.actionPerformed(null);
            err = Server();
            }
        */
        cmd.remove(cmd.size()-1); 
        }
              
    public static void main(String[] args) {
        String serverLocation = System.getProperty("server");
        filename = args.length>0?args[args.length-1]:null; 
        file = filename!=null?new File(filename):(File) null;
        Main.args = args;
        cmd = new ArrayList();
        cmd.add(serverLocation);
        for (int i=0;i<args.length-1;i++) cmd.add(args[i]);
        frame.chooser = new MyFileChooser(file);
        if (filename!=null) {
           if (filename.endsWith(".tbf")) 
                frame.chooser.setFileFilter(frame.chooser.tbfFilter);
           else
           if (filename.endsWith(".aut")) { 
                if (frame.chooser.autFilter != null)
                  frame.chooser.setFileFilter(frame.chooser.autFilter);
                else filename = null;
                }
          else
          if (filename.endsWith(".bcg")) { 
                if (frame.chooser.bcgFilter != null)
                  frame.chooser.setFileFilter(frame.chooser.bcgFilter);
                else filename = null;
                }
           else
           if (filename.endsWith(".svc")) { 
                if (frame.chooser.svcFilter != null)
                  frame.chooser.setFileFilter(frame.chooser.svcFilter);
                else filename = null;
                }
           else
           if (filename.endsWith(".trc")) 
                frame.chooser.setFileFilter(frame.chooser.trcFilter);
           else
           if (filename.endsWith(".dir")) 
                frame.chooser.setFileFilter(frame.chooser.dirFilter);
           else
           if (filename.endsWith(".dmp")) 
                frame.chooser.setFileFilter(frame.chooser.dmpFilter);
           else {
               filename = null;
               cmd.add(args[args.length-1]);
               }
           }
        StartServer();
        frame.savetracesAction.setEnabled(!frame.chooser.isAutFile());
        frame.levelUpAction.setEnabled(!frame.chooser.isAutFile());
        frame.levelDownAction.setEnabled(!frame.chooser.isAutFile());
        frame.resetAction.setEnabled(!frame.chooser.isAutFile());
        frame.stateAction.setEnabled(!frame.chooser.isAutFile());
        frame.first = false;
          
    }
    }
