/*$Id: Mgr.java,v 1.17 2007/06/29 13:30:57 bertl Exp $*/
package jsim;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.net.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.text.*;

class Elapsed {
   private long hours, minutes, seconds;
   private String s;
   public String toString() {return s;}
   
   Elapsed(long msec) {
      long timeInSeconds = msec/1000;
      hours = timeInSeconds / 3600;
      timeInSeconds = timeInSeconds - (hours * 3600);
      minutes = timeInSeconds / 60;
      timeInSeconds = timeInSeconds - (minutes * 60);
      seconds = timeInSeconds;
      s =""+hours+"h:"+minutes+"m:"+seconds+"s";
   }
}  

class Snapshot extends JSlider {

   Snapshot() {
      super(0,10,1);
      this.setPreferredSize(new Dimension(300,70));
      setBorder(BorderFactory.createTitledBorder(
      BorderFactory.createEtchedBorder(), 
      "Seconds between Proc Info",
      TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
      setMajorTickSpacing(1);
      // setMinorTickSpacing(20);
      setPaintTicks(true);
      setPaintLabels(true);
      }
   }
   
class RefreshTime extends JSlider implements ChangeListener {

    public void stateChanged(ChangeEvent e) {
        JSlider source = (JSlider)e.getSource();
        if (!source.getValueIsAdjusting()) {
            int fps = (int)source.getValue();
            Mgr.refreshTimer.stop();
            Mgr.refreshTimer.setDelay(fps*10);
            if (!Mgr.refreshTime.isDirect()) Mgr.refreshTimer.start();
        }
    }
   
   boolean isDirect() {
      return getValue()==getMinimum();
      }
      
   RefreshTime() {
      super(0,200,10);
      this.setPreferredSize(new Dimension(300,70));
      setBorder(BorderFactory.createTitledBorder(
      BorderFactory.createEtchedBorder(), "Milliseconds between Refresh",
      TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
      setMajorTickSpacing(25);
      // setMinorTickSpacing(1);
      setPaintTicks(true);
      setPaintLabels(true);
      addChangeListener(this);
      }
   }

class FileInfoTime extends JSlider implements ChangeListener { 

   public void stateChanged(ChangeEvent e) {
        JSlider source = (JSlider)e.getSource();
        if (!source.getValueIsAdjusting()) {
            int fps = (int)source.getValue();
            if (fps==0) Mgr.fileInfoTimer.stop();
            else {
              if (!Mgr.fileInfoTimer.isRunning()) 
                   Mgr.fileInfoTimer.start();
              Mgr.fileInfoTimer.setDelay(fps*1000);  
            }
        }
      }
        
   FileInfoTime() {
      super(0,60,10);
      this.setPreferredSize(new Dimension(300,70));
      setBorder(BorderFactory.createTitledBorder(
      BorderFactory.createEtchedBorder(), 
           "Seconds between Output Size Info (0=off)",
      TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
      setMajorTickSpacing(5);
      // setMinorTickSpacing(1);
      setPaintTicks(true);
      setPaintLabels(true);
      addChangeListener(this);
      }
   }
         
class AliveMsg extends Msg {  
  public AliveMsg() {
     setId("alive");
     } 
       
  public boolean Do() {
    Runnable update = new Runnable() {
        public void run() {
        Mgr.info.setValue(4, DateFormat.getInstance().format(Mgr.currenttime));
        Mgr.info.setValue(5, new Elapsed(Mgr.passedtime).toString());
        }};
        try {
          Mgr.currenttime = new Date( 
           new Integer((String)(argList.remove(0))).longValue()*1000);
          Mgr.passedtime = Mgr.currenttime.getTime()-Mgr.starttime.getTime();
         SwingUtilities.invokeAndWait(update);
         }
       catch (Exception e) {
          e.printStackTrace();
          }
     return true;
     }
  }
  
class SizeMsg extends Msg {  
  public SizeMsg() {
     setId("size");
     }
          
  public boolean Do() {
    Runnable update = new Runnable() {
        public void run() {
        Mgr.info.setValue(6, Mgr.dmpSize);
        }};
        try {
          Mgr.dmpSize = (String)(argList.remove(0));
          SwingUtilities.invokeAndWait(update);
          }
       catch (Exception e) {
          e.printStackTrace();
          }
     return true;
     }
  }   
class FinishedMsg extends Msg {   
  public FinishedMsg() {
     setId("finished");
     }
        
  public boolean Do() {
     Runnable updateTable = new Runnable() {
          public void run() {
              if (argList!=null) Mgr.table.update(argList, true);
          }};
     if (Mgr.table != null)
     Mgr.table.update(argList, Mgr.refreshTime.isDirect());
     /*     
     if (!Mgr.refreshTime.isDirect()) Mgr.table.update(argList, false);
     else {
     try {
       SwingUtilities.invokeAndWait(updateTable);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
        }
     */
     return true;
     }
  }

class ProgressMsg extends Msg { 
  
  
  public ProgressMsg() {
     setId("progress");
     }
        
  public boolean Do() {
     Runnable updateTable = new Runnable() {
          public void run() {
// System.err.println("argList:"+argList);
              if (Mgr.clientTable != null) {
                   Vector v = Mgr.clientTable.update(argList);
                   /*
		   if (Mgr.table!=null) {
		        Mgr.table.progressUpdate(v);
		   }
                   */
		   }
          }};
     try {
       SwingUtilities.invokeAndWait(updateTable);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }

class LogMsg extends Msg { 
    
  public LogMsg() {
     setId("log");
     }
        
  public boolean Do() {
     Runnable updateTable = new Runnable() {
          public void run() {
// System.err.println("argList:"+argList);
              if (Mgr.logTable != null) 
                   Mgr.logTable.update(argList);
          }};
     try {
       SwingUtilities.invokeAndWait(updateTable);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
class WeightMsg extends Msg { 
    
  public WeightMsg() {
     setId("weight");
     }
        
  public boolean Do() {
     Runnable updateTable = new Runnable() {
          public void run() {
// System.err.println("argList:"+argList);
              if (Mgr.dbsTable != null && Mgr.dbsTable.weightTree != null) 
                   Mgr.dbsTable.weightTree.update(argList);
          }};
     try {
       SwingUtilities.invokeAndWait(updateTable);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }
    
class HostsMsg extends Msg { 
    
  public HostsMsg() {
     setId("hosts");
     }
     

                       
  public boolean Do() {
     Runnable updateTable = new Runnable() {
          public void run() {
              Mgr.table.firstColumnUpdate(argList);
              Mgr.hosts = (String[]) argList.toArray(new String[0]);
              if (Mgr.hosts != null && Mgr.pids != null) Mgr.update();
          }};
     try {
       SwingUtilities.invokeAndWait(updateTable);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
              if (!Mgr.timer.isRunning()) {
                       Mgr.timer.start(); 
                       }
              if (!Mgr.refreshTimer.isRunning() && 
                 !Mgr.refreshTime.isDirect()) Mgr.refreshTimer.start();
              if (!Mgr.fileInfoTimer.isRunning()) Mgr.fileInfoTimer.start(); 
     return true;
     }
  }
 
 class PidMsg extends Msg { 
    
  public PidMsg() {
     setId("pid");
     }
        
  public boolean Do() {
     Runnable updatePid = new Runnable() {
          public void run() {
              Mgr.pids = (String[]) argList.toArray(new String[0]);
              if (!Mgr.timer.isRunning()) Mgr.timer.start();
              if (Mgr.hosts != null && Mgr.pids != null) Mgr.update();
          }};
     try {
       SwingUtilities.invokeAndWait(updatePid);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }

class DisconnectMsg extends Msg {  
  public DisconnectMsg() {
     setId("disconnect");
     } 
      
  public boolean Do() {
      Runnable update= new Runnable() {
          public void run() {
	  /*
          Mgr.disconnectCount++;
          if (Mgr.disconnectCount==2) System.exit(0); 
	  */   
          }};
     try {
       SwingUtilities.invokeAndWait(update);
       }
       catch (Exception e) {
        e.printStackTrace();
        }
     return true;
     }
  }     
       
  
class ExitMsg extends Msg {  
  public ExitMsg() {
     setId("exit");
     } 
       
  public boolean Do() {
     Runnable update = new Runnable() {
        public void run() {
        Mgr.info.setValue(6, Mgr.dmpSize);
        }};
        try {
          if (argList.size()>0) {
             Mgr.dmpSize = (String)(argList.remove(0));
             SwingUtilities.invokeAndWait(update);
             }
          }
       catch (Exception e) {
          e.printStackTrace();
          }
     return true;
     }
  }
  


class MyTimer extends javax.swing.Timer {        
   MyTimer(int msec) {       
      super(msec, new ActionListener() {
     public void actionPerformed(ActionEvent ae) {
        if (Mgr.question==null) return;
        if (Mgr.dbsTable !=null && Mgr.testConnection()) {
            Mgr.question.sendMsg(new InformMsg());
	if (Mgr.dbsTable !=null && Mgr.dbsTable.isAdbExpanded()) 
               Mgr.question.sendMsg(new ActionMsg());
	if (Mgr.dbsTable !=null) 
               Mgr.question.sendMsg(new TermMsg());
	}
        } }) ;
        // setCoalesce(false);
        // setLogTimers(true);
      } 
   }

class RefreshTimer extends javax.swing.Timer {       
   RefreshTimer(int msec) {       
      super(msec, new ActionListener() {
     public void actionPerformed(ActionEvent ae) {
        Mgr.table.showChanges();
        } }) ;
      } 
   }

class FileInfoTimer extends javax.swing.Timer {       
   FileInfoTimer(int msec) {       
      super(msec, new ActionListener() {
      
     public void actionPerformed(ActionEvent ae) {
        Mgr.request.sendMsg(new SizeMsg());
        // Mgr.dumpJid();
        } 
        }) ;
      } 
   } 
           
abstract class ExtendAction extends AbstractAction {
          public ExtendAction(String text, String desc) {
              super(text);
              putValue(SHORT_DESCRIPTION, desc);
          }
          }

class Waiting extends JFrame {
       // JProgressBar p = new JProgressBar(0,100);
       JLabel l = new JLabel("Listening to port: "+Mgr.FIRSTCONTACT);
       JPanel p = new JPanel();
       Waiting () {
          super("contact v"+ Mgr.version);
          getContentPane().setLayout(new BoxLayout(getContentPane(), 
              BoxLayout.Y_AXIS));
          p.setBorder(BorderFactory.createEtchedBorder());
          p.add(l);
          getContentPane().add(p);
          setBounds(400,400,250,100);
          addWindowListener(new WindowAdapter() {
             public void windowClosing(WindowEvent ev) {
	       System.exit(0);
               }
            });
          // pack();  
          } 
       } 
               
class Screen extends JFrame {
    JPanel tb = new JPanel();
    // private JToolBar tb = new JToolBar();
    Screen() {
      tb.setBorder(BorderFactory.createTitledBorder(null, 
       "contact v"+ Mgr.version,
       TitledBorder.CENTER, TitledBorder.DEFAULT_POSITION));
      tb.add(Mgr.abortButton); 
      /*
       tb.add(new ExtendAction("inspect","inspecting") {
             public void actionPerformed(ActionEvent e) {
             System.exit(0);
                  }
             });
       */
       tb.add(Mgr.disconnectButton);
       getContentPane().setLayout(new BoxLayout(getContentPane(), 
              BoxLayout.Y_AXIS));
       Mgr.info.setPreferredSize(new Dimension(650,50));
       Mgr.display.setPreferredSize(new Dimension(650,100)); 
       // setSize(850,850);
       // toolbars.add(tb);   
       getContentPane().add(tb);
       getContentPane().add(Mgr.info);
       getContentPane().add(Mgr.table);
       getContentPane().add(Mgr.display);
       getContentPane().add(Mgr.clientTable);
       getContentPane().add(Mgr.dbsTable);
       JPanel p = new JPanel();
       p.add(Mgr.refreshTime);
       p.add(Mgr.snapshot);
       p.add(Mgr.fileInfoTime);
       getContentPane().add(p);
       getContentPane().add(Mgr.logTable);
       pack();
       addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent ev) {
          Mgr.dumpJid();
	  Mgr.request.sendMsg(new DisconnectMsg()); 
	  Mgr.question.sendMsg(new DisconnectMsg());
	  /* if (Mgr.mgr.isClosed()) */ System.exit(0);
        }
      }); 
       }
    }
     
public class Mgr  { 
    static int FIRSTCONTACT;
    final static String version = getVersion();
    static Info info;
    static MyTimer timer = new MyTimer(1000);
    static Info display = new Info(2, new String[]{
       "level", "explored", "visited", "enabled", "transitions",
       "total levels","explored","visited", "enabled", "transitions"});
    static int nsegments;
    static String dmpSize="??";
    static Date starttime, currenttime;
    static long passedtime;
    static Waiting waiting;
    static Socket Accept(ServerSocket server) throws IOException{
         Socket s = server.accept();
	 return s;
         }
    /*
    static final SimpleDateFormat dateFormat = 
        new SimpleDateFormat("D'd':H'h':m'm':s's'");
    */
    static int npars;
    static Hashtable hostdb = new Hashtable();
    static String jid;
    static String[] hosts;
    static String[] pids;
    static ProgressTable table;
    static ClientTable clientTable;
    static LogTable logTable = new LogTable();
    static DbsTable dbsTable;
    static ServerSocket server;
    static Screen screen;
    static Snapshot snapshot = new Snapshot();
    static RefreshTime refreshTime = new RefreshTime();
    static FileInfoTime fileInfoTime = new FileInfoTime();
    static RefreshTimer refreshTimer = 
                         new RefreshTimer(refreshTime.getValue()*10);
    static FileInfoTimer fileInfoTimer = 
                         new FileInfoTimer(fileInfoTime.getValue()*1000);
    static JButton abortButton =
         new JButton(new ExtendAction("abort","abort instantiators") {
             public void actionPerformed(ActionEvent e) {
             Mgr.request.sendMsg(new ExitMsg());
             // System.exit(0);
                  }
             })
        ,
    disconnectButton = new JButton(new ExtendAction("disconnect","disconnecting") {
             public void actionPerformed(ActionEvent e) {
                  Mgr.dumpJid();
	          Mgr.request.sendMsg(new DisconnectMsg());
		  Mgr.question.sendMsg(new DisconnectMsg());
	          /* if (Mgr.mgr.isClosed()) */ System.exit(0);
                  }
             });
    static int serverPort, port;
    static String hostname;
    static Object msg[][] = new Object[][] {
       {"hello", new HelloMsg()},
       {"hosts", new HostsMsg()},
       {"pid", new PidMsg()},
       {"info",new InfoMsg(Mgr.display)},
       {"finished", new  FinishedMsg()},
       {"progress", new  ProgressMsg()},
       {"log", new  LogMsg()},
       {"weight", new  WeightMsg()},
       {"alive", new  AliveMsg()},
       {"size", new  SizeMsg()},
       {"exit", new  ExitMsg()},
       {"disconnect", new  DisconnectMsg()}
       };
    static Object dbsMsg[][] = new Object[][] {
       {"start", new StartMsg()},
       {"disconnect", new  DisconnectMsg()},
       {"action", new  ActionMsg()},
       {"term", new  TermMsg()},
       {"exit", new  ExitMsg()},
       {"inform", new InformMsg()}
       };
       
    static String filename;
    static Socket socket, mgr, dbs;
    static public MsgHandler request, question; 
    static private Thread mgrThread, dbsThread,
      exitThread = new Thread(new Runnable() {
        public void run() {
	  if (Mgr.mgr!=null && !Mgr.mgr.isClosed()) {
	  if (Mgr.request!=null) Mgr.request.sendMsg(new DisconnectMsg()); 
	  if (Mgr.question!=null) Mgr.question.sendMsg(new DisconnectMsg());
	 }
       }});
    
    static void dumpJid() {
       if (Mgr.jid!=null) {
           try {
           File f = new File(Mgr.jid);
           if ((!f.exists() && new File(".").canWrite() || f.canWrite()) && 
              JOptionPane.showConfirmDialog(null,(Object) (
                  "Save screen. Accessible by  \"contact "+
                    Mgr.jid.substring(0, Mgr.jid.lastIndexOf('.'))+"\""), 
                  "Save screen in file "+Mgr.jid, JOptionPane.YES_NO_OPTION)==
                  JOptionPane.YES_OPTION) {
           FileOutputStream fos = new FileOutputStream(f);
           ObjectOutputStream oos = new ObjectOutputStream(fos);
           oos.writeObject(Mgr.info);
           // oos.writeObject(Mgr.table);
           oos.writeObject(Mgr.display);
           oos.writeObject(Mgr.clientTable);
           oos.writeObject(Mgr.logTable);
           // oos.writeObject(Mgr.dbsTable);
           oos.close();
           }
           }
           catch (Exception e) {
               e.printStackTrace();
               System.exit(1);
               }
           }
        }
        
    static boolean testConnection() {
        if (!Mgr.request.sendMsg(new AliveMsg())) { 
            abortButton.setEnabled(false);
            table.update(((Vector) null),true);
            try  {
	          // System.err.println("Close");
	          mgr.close(); // dbs.close();
		  timer.stop();
                  fileInfoTimer.stop();
		  mgrThread.interrupt(); 
		  dbsThread.interrupt();  
              }
            catch (IOException e) {
              System.err.println(e);
              e.printStackTrace();
              }
            return false;  
            }
      return true;
      }
        
    static public void start() {
      // System.out.println("Start:"+Mgr.nsegments+" "+Mgr.hosts);
      for (int i=0;i<Mgr.nsegments;i++) {
          Mgr.hostdb.put(Mgr.hosts[i], new Hashtable());
          }
      for (int i=0;i<Mgr.nsegments;i++) {
	   ((Hashtable) Mgr.hostdb.get(Mgr.hosts[i])).put(Mgr.pids[i],
	   (Object) new Integer(i));
          }
      // System.out.println("End:"+Mgr.nsegments+" "+Mgr.hosts);
      }
             
    static public void update() {
    Mgr.clientTable.firstUpdate(Mgr.hosts, Mgr.pids);
    start();
    }
    
    static String getHostName() {
       try {
         InetAddress machine = InetAddress.getLocalHost();
         return machine.getHostName();
         }
       catch (IOException e) {
           System.err.println(e);
           System.err.println("Cannot get local host");
           System.exit(1);
           }
       return null;
       }
         
    static void Connect() {
       try {
        if (hostname==null) {
           waiting.setVisible(true);
           server = new ServerSocket(FIRSTCONTACT);
           socket = server.accept();
           waiting.setVisible(false);
           // System.err.println("Connected:"+FIRSTCONTACT);
           }
        else socket = new Socket(hostname, port);
        }
        catch (IOException e) {
           System.err.println(e);
           /* System.err.println(
           "No instantiator is running on "+hostname+":"+port);
           System.err.println("Call \"contact <job number> <host>\""); */
           System.exit(1);
           }
	// System.out.println("After First connect:"+hostname+" "+socket);
        try {
	DataOutputStream out = new DataOutputStream(socket.getOutputStream());
        DataInputStream in = new DataInputStream(socket.getInputStream());
	out.writeUTF(getHostName()); out.flush();
        try {
          serverPort = new Integer(in.readUTF()).intValue();
          // System.err.println("Received port:"+serverPort);
          }
       catch (NumberFormatException e) {
           System.err.println(e);
           System.exit(1); 
           }  
        // System.err.println("serverPort:"+serverPort);
	if (socket!=null) socket.close(); if (server!=null) server.close();
        }
      catch (IOException e) {
           System.err.println(e);
           System.err.println("Cannot get local host");
           System.exit(1);
           }
	// System.out.println("After Second connect");
      // System.err.println("Before Accept");
      try {
	server = new ServerSocket(serverPort);
	mgr = Accept(server);
        dbs = Accept(server);
        }
       catch (IOException e) {
        System.err.println(e);
           System.err.println("Contact cannot use port "+serverPort);
           System.exit(1);
           }
       // System.err.println("After Accept");
       }
    
    private static void begin() {
         Runtime.getRuntime().addShutdownHook(exitThread);
         try {
         Connect(); 
         request = new MsgHandler(mgr.getInputStream(), 
                                  mgr.getOutputStream(), screen, msg);
         mgrThread = new Thread(request);
         mgrThread.start();
         request.sendMsg(new HelloMsg());
         question = new MsgHandler(dbs.getInputStream(), 
                                  dbs.getOutputStream(), screen, dbsMsg);
         dbsThread = new Thread(question);
         dbsThread.start();
	 question.sendMsg(new StartMsg());
         } 
         catch (IOException e) {System.err.println(e);
           System.err.println("Call \"contact <job number> <host>\" or");
           System.err.println("call \"contact <host>\"");
           System.exit(1);
           }
       }
    
    public static int firstContact(String s) {
       return 20000+100*(int) (s.charAt(0))+
                  (int) (s.charAt(s.length()-1));
       }
         
    public static void main(String[] args) {
       FIRSTCONTACT = firstContact(System.getProperty("user.name"));
       if (args.length==0) {
           waiting = new Waiting();
           begin();
           }
       else
       try {
       int jid = new Integer(args[0]).intValue();
       port = jid%10000+30000;
       if (args.length>=2) {
            hostname = args[1];
            begin();
            }
       else new Frozen(""+jid+".jid").setVisible(true);
       }
       catch (NumberFormatException e) {
            {
              System.err.println("Enter \"contact <job_id> <host_name>\"");
              System.exit(0);
             }
           }   
    }
    
    static String getVersion() {
       return "2.17.13";
       }
  }
