/*$Id: Proc.java,v 1.3 2005/12/22 10:41:10 bertl Exp $*/
package jsim;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import java.net.*;

// Reads from clients % cpu and % memory. 
// This will be done by triggering repeatedly "mgrd" with "y" or "n"

class Accept extends Thread {

    Runnable stopped = new Runnable() {
        public void run() {
            for (int i=0;i<Mgr.nsegments;i++) 
               Mgr.clientTable.ended(i);
        }};
        
    Accept() {
       try {
           Mgr.server.setSoTimeout(20000*Mgr.snapshot.getValue()+100);
           }
        catch (SocketException e) {
         e.printStackTrace();
         System.exit(1);
         }
      }
       
    public void run() {
      try {
      while (true) {
        if (Mgr.server!=null) {
           Socket socket = Mgr.server.accept();
           /* System.err.println("Accepted:Inp:"+socket.isInputShutdown()+
           " Outp:"+socket.isOutputShutdown()); */
	   Proc proc = new Proc(socket);
	   }
        }
      // System.err.println("End run");
      }
      catch (SocketTimeoutException e) {
         // System.err.println("Timeout");
         try {
            Mgr.server.close();
            SwingUtilities.invokeAndWait(stopped);
            }
         catch (IOException es) {
           es.printStackTrace();
           }
         catch (Exception ee) {
            ee.printStackTrace();
            System.exit(1);
            }
         }
      catch (Exception e) {
         e.printStackTrace();
         }      
      }
      }
    
class Proc extends Thread {
   
   private String s;
   private String hostname;
   private int row;
   private BufferedReader in;
   private PrintStream out;
   private Socket socket;
   
   Proc(Socket socket) { 
      try {
      in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
      out = new PrintStream(socket.getOutputStream());
      this.socket = socket;
      hostname = in.readLine();
      if (Mgr.hostdb.get((Object) hostname)==null) {
          // System.err.println("Cannot find "+hostname);
	  this.start();
	  return;
          }
      Hashtable db = 
      new Hashtable((Hashtable) (Mgr.hostdb.get((Object) hostname)));
      // System.err.println("Proc:"+hostname);
      while (true) {
        try {
         s = in.readLine();
         }
        catch (IOException e) {
          System.err.println(e);
          this.start();
          return;
          }
         if (s!=null) {
            // System.err.println("S1:"+s);
            if (s.startsWith("voorbij", 0)) {
            // System.err.println("START");
	       Iterator it = db.values().iterator(); 
	       while (it.hasNext()) {
	          row = ((Integer) it.next()).intValue();
	          // System.err.println("Not removed:"+row);
	          SwingUtilities.invokeAndWait(endedTable);
	          }  
               this.start();
               return;
               }
            try {
            String t = new StringTokenizer(s).nextToken();
            Object u = db.get(t);
            if (u!=null) {
              db.remove(t); 
              // System.err.println("u:"+u);
              row = ((Integer) u).intValue();
              SwingUtilities.invokeAndWait(updateTable);
              }
            }
          catch (NoSuchElementException e) {
             System.err.println(e);
             }
         }
        }	
      }
      catch (Exception e) {
        System.err.println(e);
        System.exit(1);
        }
      }
          
  public void run() {
    try {
       // System.err.println("sleep:"+Mgr.snapshot.getValue()); 
       sleep(Mgr.snapshot.getValue()*1000);
       out.println(Mgr.mgr.isClosed()?"n":"y");
       out.flush();
       socket.close();
       }
    catch (Exception e) {
        e.printStackTrace();
        System.exit(1);
        }
    }
            
   Runnable updateTable = new Runnable() {
        public void run() {
            Mgr.clientTable.lastColumnsUpdate(row, s);
        }}; 

   Runnable endedTable = new Runnable() {
        public void run() {
            Mgr.clientTable.ended(row);
        }};
                 
      
   }
