/* $Id: ProgressTable.java,v 1.4 2005/09/12 13:56:54 bertl Exp $ */
package jsim;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
/**
The scrollable panel which contains a table. 
*/
class ProgressTable extends JScrollPane {
  private final int nsegments;
  private final Color[][] color;
  private final String[][] data;
  private final long[][] calc;
  private final Color headerBackground;
  private TableModel dm;
  private DefaultTableColumnModel dcm;
  /**  The table which will be displayed. */
  public JTable table;
  public String[] firstCol = null;
  /** The renderer of the 0th column. */
  private final TableCellRenderer renderer0;
  
  class Renderer extends DefaultTableCellRenderer {
    public Component getTableCellRendererComponent(JTable table,
       Object value, boolean isSelected, boolean hasFocus, int row,
       int column) {
       Component c = super.getTableCellRendererComponent(table, value, 
           isSelected, hasFocus, row, column);
       c.setBackground(color[row][column-1]!=null?color[row][column-1]:Color.white);
       return c;
       }
    }
   
   class Renderer0 implements TableCellRenderer {
    public Component getTableCellRendererComponent(JTable table,
       Object value, boolean isSelected, boolean hasFocus, int row,
       int column) { 
          Component c = renderer0.getTableCellRendererComponent(table, value, 
           isSelected, hasFocus, row, column);
       c.setBackground(headerBackground);
       return c;
       } 
   }
   
  /** The renderer of the nth column. */              
  private final Renderer renderer1 =  new Renderer();
  
  public void showChanges() {
     ((AbstractTableModel) table.getModel()).fireTableDataChanged();
     }
     
  String Human(String b) {
     try {
       long  bytes = new Long(b).longValue();
       return Human(bytes); 
     }
     catch (NumberFormatException e) {
            e.printStackTrace();
            System.exit(1); 
     }
     return null;
     }
  
  private long sum(long[] v) {
    long r = 0;
    for (int i=0;i<v.length;i++) r+=v[i];
    return r;
    }

  private long max(long[] v) {
    long r = 0;
    for (int i=0;i<v.length;i++) if (v[i]>r) r=v[i];
    return r;
    }

  private long min(long[] v) {
    long r = 1000000;
    for (int i=0;i<v.length;i++) if (v[i]<r) r=v[i];
    return r;
    }
  
  String Human(long bytes) {
       // System.err.println("Human:"+b);
       long kilo = 1024;
       long mega = kilo*kilo;
       long giga = mega*kilo;
       long gigaBytes = bytes / giga;
       bytes = bytes - (gigaBytes * giga);
       long megaBytes = bytes / mega;
       bytes = bytes - (megaBytes * mega);
       long kiloBytes = bytes / kilo;
       bytes = bytes - (kiloBytes * kilo);
       if (gigaBytes>0) return ""+gigaBytes+"."+10*megaBytes/kilo+"G";
       if (megaBytes>0) return ""+megaBytes+"."+10*kiloBytes/kilo+"M";
       return ""+kiloBytes+"K";
       }

  String Fp(long d) {
       return ""+d/10+"."+d%10;
       }
 /*    
  public void progressUpdate(Vector v) {
  try {
      Integer d = (Integer) (v.remove(0));
      int segment = d.intValue();
      for (int j=0;v.size()>0;j++)  {
       String s = (String) (v.remove(0));
       long  bytes = new Long(s).longValue();
       calc[j][segment]= bytes;
       if (v.size()>=4) {
         data[segment][j] = Human(bytes);
         data[nsegments][j] = Human(sum(calc[j]));
         }
       else { 
         switch(v.size()) {
         case 3: 
                 data[segment][j] = Fp(bytes)+"msec";
                 data[nsegments][j] = Fp(sum(calc[j])/nsegments)+"msec";
                 break;
         case 2: data[segment][j] = s; 
                 data[nsegments][j]=""+sum(calc[j]);
                 break;
         case 1: data[segment][j] = (calc[4][segment]==0?"":Fp(bytes)+"msec"); 
                 data[nsegments][j]=(calc[4][segment]==0?"":""+Fp(min(calc[j]))+"msec");
                 break;
         case 0: data[segment][j] = (calc[4][segment]==0?"":Fp(bytes)+"msec"); 
                 data[nsegments][j]= (calc[4][segment]==0?"":""+Fp(max(calc[j]))+"msec");
                 break;
         }
         }
       }
       ((AbstractTableModel) 
        table.getModel()).fireTableRowsUpdated(segment, segment);
       }
      catch (NumberFormatException e) {
        e.printStackTrace();
        System.exit(1); 
      }
     }
 */
       
  public void update(Vector v, boolean direct) {
         if (v==null) { 
         for (int i=0;i<nsegments;i++) {
            for (int j=0;j<nsegments;j++) {
                color[i][j]=Color.white;
            }
          }
          if (direct)
          ((AbstractTableModel) table.getModel()).fireTableDataChanged();
          }
         else
         if (v.size()==0) { 
         for (int i=0;i<nsegments;i++) {
            for (int j=0;j<nsegments;j++) {
                color[i][j]=Color.red;
            }
          }
          if (direct)
          ((AbstractTableModel) table.getModel()).fireTableDataChanged();
          }
          else if (v.size()==1) {  
            String sval = (String) (v.get(0));
               try {
                 int d = new Integer(sval).intValue();
                 for (int i=0;i<nsegments;i++) {
                    color[i][d]=Color.green;
                  }
                  for (int i=0;i<nsegments;i++) {
                    color[d][i]=Color.green;
                  }
                 if (direct)
                 ((AbstractTableModel) table.getModel()).fireTableDataChanged();
                 }
            catch (NumberFormatException e) {
              e.printStackTrace();
              System.exit(1); 
            }
           }
         else if (v.size()==2) {  
            String sval1 = (String) (v.get(0));
            String sval2 = (String) (v.get(1));
               try {
                 int d1 = new Integer(sval1).intValue();
                 int d2 = new Integer(sval2).intValue();
                 color[d1][d2]=Color.yellow;
                 if (direct)
                 ((AbstractTableModel) 
                 table.getModel()).fireTableCellUpdated(d1, d2+1);
                 }
            catch (NumberFormatException e) {
              e.printStackTrace();
              System.exit(1); 
            }
           }
   }
   
   
   public void firstColumnUpdate(Vector v) {
        firstCol = ((String[]) v.toArray(new String[0]));
        // System.out.println(firstCol);
        ((AbstractTableModel) table.getModel()).fireTableDataChanged();
        }
        
  /** The column model belonging to the table. */          
  class DataTableColumnModel extends DefaultTableColumnModel {
      class MyTableColumn extends TableColumn {
         MyTableColumn(int i, String name, TableCellRenderer renderer) {
            super(i);
            setHeaderValue(name);
            if (renderer!=null) {
               setCellRenderer(renderer);
               if (i>0) {
                setPreferredWidth(20);
                }
               }
            else setPreferredWidth(80);
            }       
         }
      
       DataTableColumnModel() {
         TableColumn c = new MyTableColumn(0,"segment", new Renderer0());
         c.setMinWidth(40);
         addColumn(c);
         for (int i=1;i<=nsegments;i++)
            addColumn(new MyTableColumn(i,""+(i-1), renderer1));
         /*
         addColumn(new MyTableColumn(nsegments+1, "terms", null));
         addColumn(new MyTableColumn(nsegments+2, "open", null));
         addColumn(new MyTableColumn(nsegments+3, "closed", null));    
         addColumn(new MyTableColumn(nsegments+4, "latency", null));
         addColumn(new MyTableColumn(nsegments+5, "messages", null));
         addColumn(new MyTableColumn(nsegments+6, "minimum", null));
         addColumn(new MyTableColumn(nsegments+7, "maximum", null));
         */
         }     
      }
      
    
      public ProgressTable(final int nsegments) {
        this.nsegments = nsegments;
        this.color = new Color[nsegments+1][nsegments];
        this.data = new String[nsegments+1][7];
        this.calc = new long[7][nsegments];
        dm = new AbstractTableModel() {
          public int getRowCount() {return nsegments;}
          public int getColumnCount() {return nsegments+1;}
          public Object getValueAt(int r, int c) {
          if (r==nsegments && c<=nsegments) return "";
          if (c-1>=nsegments) return data[r][c-1-nsegments];
          return (Object) (c>0?"": (firstCol==null?(""+r):firstCol[r]));
          // return (Object) (c>0?"": ""+r);  
          }
        }; 
        JViewport vp;
        DataTableColumnModel dcm =  new DataTableColumnModel();
        table = new JTable(dm, dcm);
        renderer0 = table.getTableHeader().getDefaultRenderer();
        // table.getTableHeader().setForeground(Color.red);
        headerBackground = table.getTableHeader().getBackground();
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        table.setCellSelectionEnabled(false);
        table.setColumnSelectionAllowed(false);
        table.setRowSelectionAllowed(false);
        // renderer0.setForeground(Color.blue.darker());
        // renderer0.setBackground(Color.white.darker().brighter());
        renderer1.setBackground(Color.yellow);
        vp = new JViewport();vp.setView(table);
        vp.setPreferredSize(table.getPreferredSize()); 
        setViewport(vp);
        Rectangle bound = new Rectangle(new Dimension(500,500)); 
        Rectangle port = new Rectangle(
                       new Dimension(vp.getPreferredSize()));
        bound = port.intersection(bound); 
        if (!bound.equals(port)) { 
            getViewport().setPreferredSize(bound.getSize());
            } 
        }
    }
 

