/*$Id: WeightTree.java,v 1.1 2006/09/19 13:42:58 bertl Exp $*/
package jsim;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.border.*;




class  WeightTree extends JScrollPane {

   class WeightNode extends DefaultMutableTreeNode {
     private Hashtable weights = new Hashtable();
     
     public void update(String t, String d) {
         DefaultMutableTreeNode n = (DefaultMutableTreeNode) (weights.get(t));
         DefaultTreeModel m = (DefaultTreeModel) (tree.getModel());
         if (n==null) {
             if (!d.equals("0")) {
	       n = new DefaultMutableTreeNode("weight "+t);
               int g[] = new int[]{this.getChildCount()};
	       this.add(n);
               m.nodesWereInserted(this, g);
	       weights.put(t, n);
               g[0] = 0;
               n.add(new DefaultMutableTreeNode(d));
               m.nodesWereInserted(this, g);
               }
             }
         else {
              DefaultMutableTreeNode child = 
                 (DefaultMutableTreeNode) (n.getChildAt(0));
              child.setUserObject(d);
              m.nodeChanged(child);
              }
         }
	 
     WeightNode(Object s) {
        super(s);
        }
     }
   
   private TreePath wdb = new TreePath(new DefaultMutableTreeNode("frequency"));
   final private JTree tree;
   final private DefaultMutableTreeNode top;
   final private int nsegments;
   
   public WeightTree(int nsegments) {
        this.nsegments = nsegments;
        top = (DefaultMutableTreeNode) (wdb.getLastPathComponent());
        tree = new JTree(top);
	tree.setShowsRootHandles(true);
        // tree.setRootVisible(false);
        tree.setVisibleRowCount(10);
        JViewport vp = new JViewport(); vp.setView(tree);
        setViewport(vp);
        setPreferredSize(new Dimension(150,150));
        setBorder(BorderFactory.createTitledBorder(
           BorderFactory.createEtchedBorder(), "weight distribution",
               TitledBorder.CENTER, TitledBorder.ABOVE_TOP));
        for (int i=0;i<nsegments;i++) 
          top.add(new WeightNode("segment "+i));
        top.add(new WeightNode("all segments")); 
        ((DefaultTreeModel) (tree.getModel())).nodeStructureChanged(top);
        }  
    
    public void update(Vector v) {
        try {
        int seg = Integer.parseInt((String) (v.remove(0)));  
        int n = v.size()/2;
        // System.err.println("aap:"+seg+" n= "+n);
        if (seg<0) seg = nsegments;
        if (seg<top.getChildCount()) {
           WeightNode node = (WeightNode) top.getChildAt(seg);
           for (int i=0;i<n;i++)
            node.update((String) (v.get(2*i)), (String) (v.get(2*i+1)));
        // ((DefaultTreeModel) (tree.getModel())).nodeStructureChanged(top);
           }
        }
        catch (NumberFormatException e) {
          e.printStackTrace();
          System.exit(1); 
        }
       } 
    }
