/* $Id: ClusterGraph.java,v 1.3 2003/04/16 11:46:59 bertl Exp $ */
package stateview;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import att.grappa.*;
import aterm.*;
import aterm.pure.*;
class MyJMenuBar extends JMenuBar {
private JMenu helpMenu() {
       JMenu menu= new JMenu("Help");
          menu.add(new AbstractAction("Intro") {
            public void actionPerformed(ActionEvent e) {
                 Stateview.DisplayHelp("intro.html");
            }
            });
          menu.add(new AbstractAction("Legend") {
            public void actionPerformed(ActionEvent e) {
                 Stateview.DisplayHelp("legend.html");
            }
            });
        return menu;
        }
        MyJMenuBar() {
          super();
          this.setLayout(new BorderLayout());
          this.add("Center", new JMenu(""+Data.npars+" parameters and "+
          +Data.nrows+" summands.")); 
        this.add("East", helpMenu());
        }
        MyJMenuBar(Cluster cluster) {
          super();
          this.setLayout(new BorderLayout());
          this.add("Center", new JMenu(""+cluster.pars.size()+" parameters and "+
          +cluster.smdsA.length+" summands.")); 
        this.add("East", helpMenu());
        }
     }
/**
* Cluster is the class defining a clustergraph belonging to a cluster.
* @author Bert Lisser
*/ 
class ClusterGraph extends JFrame {
        /**
        * the grappa panel of the clustergraph
        */
	GrappaPanel gp;
        /**
        * the grappa graph of the clustergraph
        */
	Graph graph = null;
        /**
        * the number of the clusters
        */
        int n_clusters;
        
   class StateGraphs extends GrappaAdapter {
       private StateGraph[] a = new StateGraph[n_clusters];
       
       StateGraphs() {
            for (int i=0;i<n_clusters;i++) {
            Cluster cluster = Data.clusters[i];
            Bundle[] edges = cluster.edges;
              // if (edges.length==0) continue;
              StateGraph stategraph = new StateGraph(cluster);
              a[i] = stategraph;
              cluster.stategraph = stategraph;
              Graph graph = stategraph.getGraph();
              GraphEnumeration e = graph.elements(GrappaConstants.EDGE);
              while (e.hasMoreElements()) {
                  Edge line  = (Edge) e.nextGraphElement();
                  int v = Integer.parseInt(
                  line.getAttribute(GrappaConstants.TAG_ATTR).getStringValue());
                  edges[v].setLine(line);
                  Transition[] transitions = edges[v].transitions;
                  boolean[] b = new boolean[Data.nrows];
                  for (int k=0;k<transitions.length;k++) {
                      int g = transitions[k].sum;
                      if (!b[g]) {
                         Stateview.lines[g].add((Object) edges[v]);
                         b[g]=true;
                         }
                      }
                  }
              e = graph.elements(GrappaConstants.NODE);
                 while (e.hasMoreElements()) {
                 Element node  = e.nextGraphElement();
                 // System.out.println("Ja in:"+node.getName());
                 cluster.table.put((Object) node.getName(), (Object) node);
                 }
            }
       }
       
       public void grappaClicked(Subgraph subg, Element elem, GrappaPoint pt, 
       int modifiers, int clickCount, GrappaPanel panel) {
       if (elem== null) return;
       if (elem.getType()==GrappaConstants.NODE) {
          int d = Integer.parseInt(
              elem.getAttribute(GrappaConstants.TAG_ATTR).getStringValue());
          //    System.err.println("Debug "+d+" "+cluster_id);
          if (Data.clusters[d].stategraph!=null) { 
             Data.clusters[d].stategraph.setVisible(true);
             }
          else {
            Data.clusters[d].stategraph = new StateGraph(Data.clusters[d]);
            Data.clusters[d].stategraph.setVisible(true);
          }
       }
     }
     public String grappaTip(Subgraph subg, final Element elem, GrappaPoint pt, int modifiers, 
        GrappaPanel panel) {
        if (elem==null) return null;
        if (elem.getType()==GrappaConstants.NODE) {
            return "Click for control flow graph";
            }
        return null;
        }
    }
    
    
   /**
   * Class constructor.
   * @param graph  the grappa cluster graph.
   * @param n_clusters the number of clusters.
   */
    
            
    public ClusterGraph(Graph graph, int n_clusters) {
        super("Choose component");
        JScrollPane scrollpane = new JScrollPane();
	this.graph = graph;
        this.n_clusters = n_clusters;
        this.graph.setMenuable(false);
        // graph.resetBoundingBox();
        java.awt.Rectangle bbox = graph.getBoundingBox().getBounds();
	// System.err.println("bbox ="+bbox);  
        // getViewport().setBackingStoreEnabled(true);
	gp = new GrappaPanel(graph);
	gp.addGrappaListener(new StateGraphs());
	gp.setScaleToFit(false);
        Stateview.ComputeBounds(gp, graph);
        JViewport vp = new JViewport();
        vp.setView(gp);
        scrollpane.setViewport(vp);
        Rectangle rec = new Rectangle(new Dimension(400,400));
        Dimension dim = rec.intersection(
        new Rectangle(new Dimension(scrollpane.getViewport().getPreferredSize())))
        .getSize();
        scrollpane.getViewport().setPreferredSize(dim);
        // JPanel panel = new JPanel();
        // panel.add("East", new JLabel(""+Data.npars+" parameters and "));
        // panel.add("West", new JLabel(""+Data.nrows+" summands."));
        // getContentPane().add("North", panel);
        getContentPane().add("Center", scrollpane);
        this.setJMenuBar(new MyJMenuBar());
        pack();
        addWindowListener(new WindowAdapter() {
		    public void windowClosing(WindowEvent wev) {
			Window w = wev.getWindow();
			w.setVisible(false);
			w.dispose();
			System.exit(0);
		    }
		});	    	    
     }
  }
 
