/* $Id: InitialState.java,v 1.1 2003/03/31 13:03:30 bertl Exp $ */
package stateview;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.lang.String;
import att.grappa.*;

/** The start point of de depth first search. */
class InitialState {
     /** The hashtable which contains the already visited elements. */
     private HashSet present = new HashSet();
     /** The stack of new starting lines. */
     private Stack lines = new Stack();
     /** The belonging grappa node. */
     private Node node;
     /** The belonging parameter. */
     private Parameter par;
     /** Class constructor. */
     InitialState(Node node, Parameter par) {
      this.node = node;
      this.par = par;
      }
      
     /** marks all pathes from initial node until this.par occurs 
     or this.par is overwritten and unmarks all pathes 
     at which this.pars occurs at the end */ 
     private boolean occursInSubgraph(Node node) {
      // System.err.println("aap");
      if (!present.add(node)) {
        // System.err.println("occursIn A:"+node.counter);
        return node.counter == 1;
        }
      Enumeration e = node.outEdgeElements();
      
      node.counter = 0;
      while (e.hasMoreElements()) {
          Bundle edge = (Bundle) (Data.lineBundle.get(e.nextElement()));
          if (edge.occursInAction(this.par) ||
            edge.occursInCondition(this.par) ||
            edge.occursInNextState(this.par)) {
            node.counter = 1; 
            /* if (!edge.isWritten(this.par))
                   lines.push(edge.getLine()); */
            return true;
            }
       }
       e = node.outEdgeElements();
       boolean r = false;
       while (e.hasMoreElements()) {
          Bundle edge = (Bundle) (Data.lineBundle.get(e.nextElement()));
          if (!edge.isWritten(this.par)) { 
             Color color = (Color) edge.getLine().getAttributeValue(
             GrappaLine.COLOR_ATTR);  
             edge.getLine().setAttribute(GrappaLine.COLOR_ATTR, 
                  (Object) (Color.magenta)); 
             if (occursInSubgraph(edge.getLine().getHead())) { 
                r = true; 
                node.counter = 1;
                edge.getLine().setAttribute(GrappaLine.COLOR_ATTR, 
                (Object) color);
                }
             }
          else {
             lines.push(edge.getLine()); 
          // System.out.println("Push");
          }
          }    
      return r;   
      }
      
/** marks the maximal uncritical pathes going from initial node */      
      void occursInSubgraph() {
          occursInSubgraph(this.node);
          while (!this.lines.empty()) {
           Edge edge = (Edge)this.lines.pop();
           if (!occursInSubgraph(edge.getHead())) {
               // System.out.println("QQQ edge "+edge);
               edge.setAttribute(GrappaLine.COLOR_ATTR, 
                  (Object) (Color.magenta)); 
               }}; 
          ((Element) this.node).getGraph().repaint();
      };     
}
